<template>
  <v-card>
    <v-card-text>
      <ValidationObserver ref="recipeForm">
        <form>
          <v-row id="Home">
            <v-col cols="12">
              <v-toolbar color="primary-accent" dark>
                <v-toolbar-title>Créer une nouvelle recette - Informations</v-toolbar-title>
              </v-toolbar>
            </v-col>
            <!-- Titre -->
            <v-col cols="12" md="7">
              <v-row>
                <v-col sm="2" md="4">
                  <v-subheader>Titre :</v-subheader>
                </v-col>
                <v-col sm="10" md=8>
                  <ValidationProvider v-slot="{ errors }" name="title" rules="required">
                    <v-text-field outlined v-model="recipe.Title" single-line type="text" :error-messages="errors" />
                  </ValidationProvider>
                </v-col>
              </v-row>
            </v-col>
            <!-- Temps de la recette -->
            <v-col cols="12" md="5">
              <v-row>
                <v-col sm="2" md="4">
                  <v-subheader>Temps de la recette</v-subheader>
                </v-col>
                <v-col sm="10" md="8">
                  <ValidationProvider v-slot="{ errors }" name="Duration" rules="required">
                    <v-text-field outlined v-model="recipe.Duration" type="time" :error-messages="errors" />
                  </ValidationProvider>
                </v-col>
              </v-row>
            </v-col>
            <!-- Commentaire de la recette -->
            <v-col cols="12" md="7">
              <v-row>
                <v-col sm="2" md="4">
                  <v-subheader>Commentaire
                    <small class="ml-1">(Optionnel)</small>
                  </v-subheader>
                </v-col>
                <v-col sm="10" md=8>
                  <ValidationProvider v-slot="{ errors }" name="Comment">
                    <v-textarea outlined v-model="recipe.Comment" rows="2" type="text" :error-messages="errors" />
                  </ValidationProvider>
                </v-col>
              </v-row>
            </v-col>
            <v-col cols="12" md="6">
              <RecipeStepsForm v-on:steps-update="stepsUpdateWatch" />
            </v-col>
            <v-col cols="12" md="6">
              <RecipeIngredientsForm v-on:ingredients-update="ingredientsUpdateWatch" />
            </v-col>
          </v-row>
        </form>
      </ValidationObserver>
    </v-card-text>
    <v-card-actions>
      <v-spacer></v-spacer>
      <v-btn text>Close</v-btn>
      <v-btn class="ml-3" color="secondary" @click="submitRecipeForm()">Créer la recette</v-btn>
    </v-card-actions>
  </v-card>
</template>

<script lang="ts">
import Vue from "vue";
import Component from "vue-class-component";
import RecipeStepsForm from "./recipeFormComponents/RecipeStepsForm.vue";
import RecipeIngredientsForm from "./recipeFormComponents/RecipeIngredientsForm.vue";
import Recipe from "../../transport/Recipe";
import { timeInputToMilliSeconds } from "../../mixins/GlobalMixins";
import RecipeService from "../../services/RecipeService";
// import RecipeStep from "@/transport/RecipeStep"

@Component({
  components: {
    RecipeStepsForm,
    RecipeIngredientsForm,
  },
})
export default class RecipeForm extends Vue {
  recipe: Recipe = new Recipe();
  recipeService: RecipeService = null;
  $refs: {
    recipeForm;
  };
  stepsUpdateWatch = steps => (this.recipe.RecipeSteps = steps);
  ingredientsUpdateWatch = ingredients =>
    (this.recipe.RecipeIngredients = ingredients);
  mounted() {
    this.recipeService = new RecipeService();
  }
  private submitRecipeForm() {
    if (!this.$store.state.connectedUser) {
      this.Toast.warning(
        "Vous devez être connecté pour réaliser cette action."
      );
      this.$store.dispatch("showLoginModal");
    } else {
      this.$refs.recipeForm.validate().then(success => {
        if (!success) return;

        let recipe = Object.assign(new Recipe(), this.recipe);

        // Fix duration format.
        recipe.Duration = timeInputToMilliSeconds(recipe.Duration.toString());

        // Ajout des numéros d'étapes
        recipe.RecipeSteps.map((element, index) => (element.Order = index + 1));
        this.recipeService.createRecipeWithFullDetails(recipe).then(recipe => {
          this.Toast.success("Votre recette à été créée avec succès");
          Vue.nextTick(() => {
            this.$router.push({
              name: "recipe",
              params: { id: recipe.Id.toString() },
            });
          });
        });
      });
    }
  }
}
</script>
